import React from 'react';
export declare const rerenderPropsList: readonly ["src", "active", "width", "height", "imgWidth", "fillColor", "strokeColor", "lineWidth", "natural", "areaKeyName", "stayHighlighted", "stayMultiHighlighted", "toggleHighlighted", "parentWidth", "responsive"];
export interface Container extends HTMLDivElement {
    clearHighlightedArea: () => void;
}
export interface MapAreas {
    id?: string;
    coords: [];
    href: string;
    shape: string;
    fillColor: string;
    strokeColor: string;
    lineWidth: number;
    preFillColor: string;
}
export interface Map {
    name: string;
    areas: Array<MapAreas>;
}
export interface CustomArea extends MapAreas {
    scaledCoords: number[];
    center?: [number, number];
}
export declare type AreaEvent = React.MouseEvent<HTMLAreaElement, MouseEvent>;
export declare type ImageEvent = React.MouseEvent<HTMLImageElement, MouseEvent>;
export interface ImageMapperProps {
    src: string;
    map?: Map;
    areaKeyName?: 'id';
    containerRef?: {
        current: HTMLDivElement;
    } | null;
    active?: boolean;
    fillColor?: string;
    strokeColor?: string;
    lineWidth?: number;
    imgWidth?: number;
    width?: number | ((e: React.MouseEvent<HTMLImageElement>) => void);
    height?: number | ((e: React.MouseEvent<HTMLImageElement>) => void);
    natural?: boolean;
    stayHighlighted?: boolean;
    stayMultiHighlighted?: boolean;
    toggleHighlighted?: boolean;
    rerenderProps?: Array<keyof ImageMapperProps>;
    responsive?: boolean;
    parentWidth?: number;
    onImageClick?: ((e: ImageEvent) => void) | null;
    onImageMouseMove?: ((e: ImageEvent) => void) | null;
    onClick?: ((area: CustomArea, index: number, e: AreaEvent) => void) | null;
    onMouseMove?: ((area: CustomArea, index: number, e: AreaEvent) => void) | null;
    onMouseEnter?: ((area: CustomArea, index: number, e: AreaEvent) => void) | null;
    onMouseLeave?: ((area: CustomArea, index: number, e: AreaEvent) => void) | null;
    onLoad?: ((e: HTMLImageElement, dimensions: {
        width: number;
        height: number;
    }) => void) | null;
}
export declare const ImageMapperDefaultProps: Partial<ImageMapperProps>;
